package de.hdm_stuttgart.mi.sda1;

import org.jdom2.*;
import org.jdom2.filter.ElementFilter;
import org.jdom2.input.SAXBuilder;
import org.jdom2.xpath.XPathExpression;
import org.jdom2.xpath.XPathFactory;

import java.io.File;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;

public class Book2Rdbms {

    private Connection conn;

    private Document doc;

    public Book2Rdbms() {
        try {
            conn = DriverManager.getConnection(
                    "jdbc:mysql://localhost/hdm?serverTimezone=UTC", "hdmuser", "XYZ");
        } catch (SQLException e) {
            System.err.println("Unable to establish connection: " + e);
            System.exit(1);
        }

        final SAXBuilder builder = new SAXBuilder();
        try {
            doc = builder.build(new File("Schema/sampledata.xml"));
                    //getClass().getClassLoader().getResource("Schema/sampledata.xml"));
        } catch (JDOMException e) {
            e.printStackTrace();
            System.err.println("Unable to parse input: " + e);
            System.exit(1);
        } catch (IOException e) {
            e.printStackTrace();
            System.err.println("Unable to read input: " + e);
            System.exit(1);
        }
    }

    public void execute() {

        final XPathExpression<Element> xpathSearchPara =
                XPathFactory.instance().compile(
                        "//para" ,
                        new ElementFilter(),
                        null ,
                        Namespace.getNamespace(null));

        System.out.println("Java stream:");
        xpathSearchPara.evaluate(doc).stream().
                map(Element::getText).forEach(System.out::println);

        System.out.println("\nSimple loop:");
        for (final Element e: xpathSearchPara.evaluate(doc)) {
            System.out.println(e.getText());
        }

    }
}
