DROP TABLE IF EXISTS Para;
DROP TABLE IF EXISTS Section;

CREATE TABLE Section (
  id CHAR(100) PRIMARY KEY
  ,title TEXT
  ,parent CHAR(100) REFERENCES Section
  ,revisionFlag CHAR(7)
  ,orderValue INT NOT NULL
);

CREATE TABLE Para (
   section CHAR(100) NOT NULL REFERENCES Section
  ,para LONGTEXT
  ,revisionFlag CHAR(7)
  ,orderValue INT NOT NULL
);


INSERT INTO  Section VALUES ('categories', 'XML Document categories', NULL,       'new',  1);
INSERT INTO  Section VALUES ('wellFormed', 'Well-formed documents',  'categories' ,NULL,  2);

INSERT INTO  Para VALUES (
  'categories', 'Documents belonging to this category do not adhere to any schema.','changed',  3);


INSERT INTO  Section VALUES ('valid', 'Valid documents',  'categories',          NULL,         4);
INSERT INTO  Para VALUES ('valid', 'Valid documents require a schema.',          NULL,         5);
INSERT INTO  Para VALUES ('valid', 'Common standards are DTD, XML Schema and Relax-NG.',NULL,  6);

INSERT INTO  Section VALUES ('api', 'Available APIs', NULL,                       'deleted',    7);
INSERT INTO  Para VALUES    ('api', 'We introduce SAX and DOM here.',             NULL,    8);
INSERT INTO  Para VALUES    ('api', 'Some APIs offer multiple language bindings.', NULL,   9);


SELECT * FROM Section;
SELECT * FROM Para;
